module Admin::SeminarsFieldHelper

  include ActionView::Helpers::FormTagHelper
  include ActionView::Helpers::FormOptionsHelper
  include ActionView::Helpers::DateHelper
  include ActionView::Helpers::TagHelper
  include ActionView::Helpers::RenderingHelper
  include ActionView::Context
  include OrbitBasis::RenderAnywhere

  include OrbitFormHelper

  def block_helper(member,index,disable = false,attribute_type=nil,signup=nil, to_require=true)
    unless self.disabled
      @index = index
      @require = to_require
      @markup_options = markup_options.merge(:disabled=>disable, :required => to_require)
      @member = member
      @attribute_value = @member.get_value_from_field_id(id,signup)
      @attribute_type = attribute_type
      @new_attribute = @attribute_value.nil?
      @attribute_value = @attribute_value || signup.seminar_signup_values.build(seminar_signup_field_id: id)
      @prefiled_value = @attribute_value.value rescue nil
      return instance_eval("render_#{markup}") rescue ""
    end
  end

  def lang_tab(str,lang)
      content_tag(:div,str,:class=>"tab-pane fade",:id=>(get_field_name_base+"tab_#{lang}"))
  end

  def render_address
    control_group_wrapper do |key,value|
      value = (can_muti_lang_input? ?  @prefiled_value[key] : @prefiled_value) rescue nil
      key_field = can_muti_lang_input? ? "[#{key}]" : ""
      place_holder= @panel_setting["placeholder"][key] rescue ''
      # result = text_area_tag(get_field_name_base + key_field,  value,@markup_options.merge({:placeholder=>place_holder,:for=>key}))
      result = text_field_tag(get_field_name_base + key_field,  value,@markup_options.merge({:placeholder=>place_holder,:for=>key}))

      add_ext= @attribute_value.address_key[key] rescue {}

      result << hidden_field_tag(get_basic_field_name_base+"[address_key][#{key}][county]",add_ext["county"],:class=>"county_#{key}", :id=>nil)
      result << hidden_field_tag(get_basic_field_name_base+"[address_key][#{key}][street_address]",add_ext["street_address"],:class=>"street_address_#{key}", :id=>nil)
      result << hidden_field_tag(get_basic_field_name_base+"[address_key][#{key}][city]",add_ext["city"],:class=>"city_#{key}", :id=>nil)
      result << hidden_field_tag(get_basic_field_name_base+"[address_key][#{key}][zip]",add_ext["zip"],:class=>"zip_#{key}", :id=>nil)
      result << hidden_field_tag(get_basic_field_name_base+"[address_key][#{key}][country]",add_ext["country"],:class=>"country_#{key}", :id=>nil)
      result << hidden_field_tag(get_basic_field_name_base+"[address_key][#{key}][indicator]",add_ext["indicator"],:class=>"indicator_#{key}", :id=>nil)
    end
  end

  def render_checkbox
     @prefiled_value ||=[]
    control_group_wrapper do 
      a = self.typeE[:option_list].collect do |key,value|
        label_tag("#{get_basic_field_name_org}_#{self.id}_#{key}",check_box_tag(get_field_name_base+"[#{key}]", true ,  (@prefiled_value.include?(key) ? true : false), { :id=>"#{get_basic_field_name_org}_#{self.id}_#{key}"})+value[I18n.locale.to_s],@markup_options.merge(:class=>"checkbox inline"))
      end.join.html_safe rescue ""
    end
  end

  def render_date 
    d = DateTime.now()

    if date_is_range?
      # fill_from = @attribute_value.get_date(:from) rescue nil
      # fill_to = @attribute_value.get_date(:to) rescue nil
      control_group_wrapper do

      case self.typeC['format']
        when 'format1'
          fill_from = (@prefiled_value && @prefiled_value["from"] ) ? @prefiled_value["from"] : d.strftime("%Y/%m/%d %H:%M")
          fill_to = (@prefiled_value && @prefiled_value["to"] ) ? @prefiled_value["to"] : d.strftime("%Y/%m/%d %H:%M")
          buf = datetime_picker(get_field_name_base+'[from]', fill_from, 'yyyy/MM/dd hh:mm', true)
          buf << ' ~ '
          buf << datetime_picker(get_field_name_base+'[to]', fill_to, 'yyyy/MM/dd hh:mm', true)
        when 'format2'
          fill_from = (@prefiled_value && @prefiled_value["from"] ) ? @prefiled_value["from"] : d.strftime("%Y/%m/%d")
          fill_to = (@prefiled_value && @prefiled_value["to"] ) ? @prefiled_value["to"] : d.strftime("%Y/%m/%d")
          buf = datetime_picker(get_field_name_base+'[from]', fill_from, 'yyyy/MM/dd')
          buf << ' ~ '
          buf << datetime_picker(get_field_name_base+'[to]', fill_to, 'yyyy/MM/dd')
        when 'format3'
          fill_from = (@prefiled_value && @prefiled_value["from"] ) ? @prefiled_value["from"] : d.strftime("%Y/%m")
          fill_to = (@prefiled_value && @prefiled_value["to"] ) ? @prefiled_value["to"] : d.strftime("%Y/%m/")
          buf = datetime_picker(get_field_name_base+'[from]', fill_from, 'yyyy/MM')        
          buf << ' ~ '
          buf << datetime_picker(get_field_name_base+'[to]', fill_to, 'yyyy/MM')
        when 'format4'
          fill_from = (@prefiled_value && @prefiled_value["from"] ) ? @prefiled_value["from"] : d.strftime("%Y")
          fill_to = (@prefiled_value && @prefiled_value["to"] ) ? @prefiled_value["to"] : d.strftime("%Y")
          buf = datetime_picker(get_field_name_base+'[from]', fill_from, 'yyyy')  
          buf << ' ~ '
          buf << datetime_picker(get_field_name_base+'[to]', fill_to, 'yyyy')
        end

        # buf = date_select(get_field_name_base+'[from]',nil,@markup_options.merge(:default=>fill_from),:class=>"input-small")
        # buf << ' ~ '
        # buf << date_select(get_field_name_base+'[to]',nil,@markup_options.merge(:default=>fill_to),:class=>"input-small")
        buf
      end
    else
      # @prefiled_value = @attribute_value.get_date
      # @prefiled_value = @attribute_value.get_date

      case self.typeC['format']
        when 'format1'
          tmp = datetime_picker(get_field_name_base, (@prefiled_value ? @prefiled_value : d.strftime("%Y/%m/%d %H:%M")), 'yyyy/MM/dd hh:mm', true)
        when 'format2'
          tmp = datetime_picker(get_field_name_base, (@prefiled_value ? @prefiled_value : d.strftime("%Y/%m/%d")), 'yyyy/MM/dd')
        when 'format3'
          tmp = datetime_picker(get_field_name_base, (@prefiled_value ? @prefiled_value : d.strftime("%Y/%m")), 'yyyy/MM')        
        when 'format4'
          tmp = datetime_picker(get_field_name_base, (@prefiled_value ? @prefiled_value : d.strftime("%Y")), 'yyyy')  
        end
      
      control_group_wrapper{tmp} 
      # control_group_wrapper{date_select(get_field_name_base,nil,@markup_options.merge(:default=>@prefiled_value),:class=>"input-small")} 

    end
  end

  def seminar_datetime_picker(object_name, value, format, time=false)
    content_tag :div, :class => "input-append datetimepick", "data-date-format"=>format, "data-picktime"=>"#{time}" do
      concat text_field_tag(object_name, value, :placeholder=>format)
      concat (content_tag :span, :class => 'add-on clearDate' do
                content_tag :i, nil, :class => 'icons-cross-3'
              end)
      concat (content_tag :span, :class => 'add-on iconbtn' do
                content_tag :i, nil, 'data-time-icon' => 'icons-clock', 'data-date-icon' => 'icons-calendar', :class=>"icons-calendar"
              end)
    end
  end

  def render_date_durnation #Need re-write low priority
    
  end

  def render_radio_button
    @prefiled_value ||=[]
    control_group_wrapper do
      self.typeE[:option_list].collect do |key,value|
        label_tag("#{get_basic_field_name_org}_#{self.id}_#{key}",radio_button_tag(get_field_name_base, key ,  (@prefiled_value.include?(key) ? true : false), {:required=>@require,:id=>"#{get_basic_field_name_org}_#{self.id}_#{key}"})+value[I18n.locale.to_s],@markup_options.merge(:class=>"radio inline"))
      end.join.html_safe
    end
  end
  def render_seminar_preferred_session
    @prefiled_value ||=[]
    @prefiled_value = Array(@prefiled_value)
    control_group_wrapper do
      @member.summary_chioices.map.with_index do |value,key|
        key = key.to_s
        label_tag("#{get_basic_field_name_org}_#{self.id}_#{key}",radio_button_tag(get_field_name_base, key ,  ((@prefiled_value.include?(key) || @prefiled_value.include?(key.to_i)) ? true : false), {:required=>@require,:id=>"#{get_basic_field_name_org}_#{self.id}_#{key}"})+value,@markup_options.merge(:class=>"radio inline"))
      end.join.html_safe
    end if @member.enable_summary_choice
  end
  def render_select
    prompt = @panel_setting["initial"][I18n.locale.to_s] rescue nil
    @markup_options.merge!(:prompt => prompt) unless prompt.nil?
    control_group_wrapper{select_tag( get_field_name_base,options_for_select(self.typeB["option_list"].collect{|p| [p[1][I18n.locale.to_s],p[0]]},@prefiled_value),@markup_options)} rescue ""
  end

  def render_text_area
     control_group_wrapper do |key,value|
      if !@prefiled_value.nil?
        value = can_muti_lang_input? ?  @prefiled_value[key] : @prefiled_value
      else
        value = nil
      end
      key = can_muti_lang_input? ? "#{key}" : I18n.locale
      place_holder= typeD["placeholder"][key] rescue ''
      name1 = can_muti_lang_input? ? (get_field_name_base + "[#{key}]") : get_field_name_base
      text_area_tag(name1,  value,@markup_options.merge(:placeholder=>place_holder,:class=>'ckeditor input-medium form-control'))
    end
  end

  def render_text_field
      a = control_group_wrapper do |key,value|
        add_more_blank = can_add_more ? "[]" : ""
        key_field = can_muti_lang_input? ? "#{key}" : I18n.locale
        place_holder= typeA["placeholder"][key_field] rescue ''
        name1 = can_muti_lang_input? ? ([get_field_name_base,add_more_blank,"[#{key_field}]"].join) : ([get_field_name_base,add_more_blank].join)
        text_field_tag(name1,  value,@markup_options.merge(:placeholder=>place_holder,:class=>'input-medium form-control'))
      end  
  end

  def date_is_range?
    is_range =  "false"
    data = get_data
    if !data.nil?
      is_range = data['is_range'] if data.has_key? "is_range"  
    end
    is_range == "true" 
  end

protected

  def valid_locales
    site = Site.first
    [I18n.locale]+(site.valid_locales-[I18n.locale])
  end

  def lang_panel_tabbable_wrapper(add_more_params,&block)
    add_more_counter = ''

    if self.markup=='text_area' #or self.markup=='address'
      tmp1 = valid_locales.collect do |key|
        if !@prefiled_value.nil?
          value = @prefiled_value[key] || @prefiled_value[key.to_s]  rescue nil
        else
          value = nil
        end
        # div_class_ary = ["tab-pane" ,"fade","#{get_pairing_tab_class({})}_#{key}"]
        div_class_ary = ["tab-pane" ,"fade"]
        if @show_set_field && @markup=='text_area'
          div_id = "ckeditor_#{get_pairing_tab_class({})}_#{key}"
        else
          div_id = "#{get_pairing_tab_class({})}_#{key}"
        end
        if can_add_more
          add_more_value = add_more_params[0][:value]
          add_more_counter = add_more_params[0][:counter]
          value = add_more_value[key] rescue nil
          div_class_ary << "add_more_item_#{add_more_counter}"
        end

        div_class = div_class_ary.join(" ")
        div_class << (key == I18n.locale ?  " active in" : '')
        content_tag(:div,yield(key,value), :id=>div_id,:class=>div_class)
      end# of VALID_LOCALES.collect for tabed input
      tmp2 = content_tag(:div,:class => 'btn-group', :data=>{:toggle=>"buttons-radio"}) do 
        buff2 = valid_locales.each.collect do |key|
            # link_entry = self.add_more ? "#{add_more_tab(:tab_btn,loop_counter,key)}" : "#tab"+id.to_s+"_#{key}"
            if @show_set_field && @markup=='text_area'
              link_entry_ary = ["#ckeditor_#{get_pairing_tab_class({})}","_#{key}"]
            else
              link_entry_ary = ["##{get_pairing_tab_class({})}","_#{key}"]
            end
            link_entry_ary << ".add_more_item_#{add_more_counter}" if can_add_more
            link_entry = link_entry_ary.join
            link_to(I18n.t(key),link_entry,:data=>{:toggle=>"tab"},:class=>"btn #{(key == I18n.locale ?  "active" : nil)}",:for=>key)
        end  # of VALID_LOCALES.collect for tabs

        buff2 << link_to((content_tag :i,'',:class=>'icon-edit'),"##{get_pairing_tab_class({})}_m_window", :role=>"button",:class=>'btn',:data=>{:toggle=>"modal"}) if self.markup == 'address'
        buff2 << link_to((content_tag :i,'',:class=>'icon-trash'),"#",:class=>"btn remove-input") if self.add_more
        buff2.join.html_safe
      end # of content ul
      tmp = content_tag :div,:class=> "tab-content textarea-lang" do
        tmp2 << tmp1.join('').html_safe
      end
    else

      # tmp = content_tag :div,:class=> (add_more || self.markup=='address') ?  "input-append" : "tab-content" do
      tmp1 = 
        content_tag :div,:class=> "tab-content" do

          buff = valid_locales.collect do |key|
            value = @prefiled_value[key] || @prefiled_value[key.to_s]  rescue nil
            # div_class_ary = ["tab-pane" ,"fade","#{get_pairing_tab_class({})}_#{key}"]
            div_class_ary = ["tab-pane" ,"fade"]

            div_id = "#{get_pairing_tab_class({})}_#{key}"


            if can_add_more
              add_more_value = add_more_params[0][:value]
              add_more_counter = add_more_params[0][:counter]
              value = add_more_value[key] rescue nil
              div_class_ary << "add_more_item_#{add_more_counter}"
            end

            div_class = div_class_ary.join(" ")
            div_class << (key == I18n.locale ?  " active in" : '')
            content_tag(:div,yield(key,value), :id=>div_id,:class=>div_class)
          end# of VALID_LOCALES.collect for tabed input

          buff.join('').html_safe

        end

      tmp2 = content_tag(:div,:class => 'btn-group', :data=>{:toggle=>"buttons-radio"}) do 
        buff2 = valid_locales.each.collect do |key|
            # link_entry = self.add_more ? "#{add_more_tab(:tab_btn,loop_counter,key)}" : "#tab"+id.to_s+"_#{key}"
            link_entry_ary = ["##{get_pairing_tab_class({})}","_#{key}"]
            link_entry_ary << ".add_more_item_#{add_more_counter}" if can_add_more
            link_entry = link_entry_ary.join
            link_to(I18n.t(key),link_entry,:data=>{:toggle=>"tab"},:class=>"btn #{(key == I18n.locale ?  "active" : nil)}",:for=>key)
        end  # of VALID_LOCALES.collect for tabs

        buff2 << link_to((content_tag :i,'',:class=>'icon-edit'),"#address-field", :role=>"button",:class=>'btn',:data=>{:toggle=>"modal"}) if self.markup == 'address'
        buff2 << link_to((content_tag :i,'',:class=>'icon-trash'),"#",:class=>"btn remove-input") if self.add_more
        buff2.join.html_safe
      end # of content ul


        
      tmp = content_tag :div,:class=> "input-append" do
        tmp1 << tmp2
      end

    end

  end


  def controls_wrapper(*add_more_params,&block)
      result = Array.new
      add_more_counter = ""

      if can_add_more
        add_more_counter = add_more_params[0][:counter] 
        add_more_value = add_more_params[0][:value]  
      end
    


    if can_muti_lang_input?
      result << lang_panel_tabbable_wrapper(add_more_params,&block)
      result << gen_modal_dialog if self.markup == "address"
      # result << add_more_unt if can_add_more
    else #cross lang field
      case can_add_more
       when true
         value = add_more_params[0][:value]  
         result << content_tag(:div,:class=>"input-append"){yield(nil,value) + link_to((content_tag :i,'',:class=>'icon-trash'),"#",:class=>"btn remove-input") }
         # result << add_more_unt
        else
         value = @prefiled_value
         result << yield(nil,value)
      end

      
    end
    if self.markup == "address"
      result
    else
      result[0]
    end

  end # of def controls_wrapper(&block)

  def control_group_wrapper(&block) 
    div_class = can_muti_lang_input? ? "col-sm-10 controls" : "col-sm-10 controls"
    # div_class = can_muti_lang_input? ? "control-group language-swich" : "control-group"
    result = ""

    case self.markup

      when "text_field"

        if can_add_more

          multipleInputs  =  
            content_tag(:div,:class=>"add-target") do
              @attribute_value.add_more_counter.times.collect do |t|
               controls_wrapper(:value=>(@prefiled_value[t] rescue nil),:counter=>t,&block)
              end.join('').html_safe # of add_more fields
            end


          temp =  content_tag(:div, multipleInputs + add_more_unt, :class=>'add-input')
          
          result = form_label + content_tag(:div,temp,:class=>div_class)  

          # result =  label +  multipleInputs + add_more_unt
          # result = label + 一堆的輸入框(要用 multipleInput editMore 包起來)  + add_more btn + hidden_fields
        else
          result = form_label + content_tag(:div,controls_wrapper(&block),:class=>div_class)
        end

      when "address"

        # address  = content_tag :div,:class=>"multipleInput editMore" do
        address  = content_tag :div,:class=>"col-sm-10" do
            form_label + content_tag(:div, controls_wrapper(&block), :class=>'add-input')
        end # of div  multipleInput editMore

        result =  address

    else
      result = form_label + content_tag(:div,controls_wrapper(&block),:class=>div_class)
    end
    result = result + end_block
    result.html_safe

  end


  def add_more_unt    
    temp_field_name =  get_basic_field_name_base + '[temp]'
    add_more = content_tag :p,:class=> 'add-btn' do
        content = link_to (content_tag :i,I18n.t(:add),:class=>"icon-plus"),"#","data-roles"=>"role_a",:class=>"trigger #{can_muti_lang_input? ? 'textLengInput' : 'textInput' } btn btn-small btn-primary"
        content << hidden_field_tag("#{temp_field_name}[count]",@attribute_value.add_more_counter ,:class=>"list_count", :id=>nil)
        content << hidden_field_tag("#{temp_field_name}[count]",get_basic_field_name_base,:class=>"field_name", :id=>nil)
        content
    end # of div
    # add_more = content_tag :div,:class=> 'controls' do
    #   content_tag :span,:class=> 'help-block' do
    #     content = link_to (content_tag :i,I18n.t(:add),:class=>"icon-plus-sign"),"#",:class=>'addinput'
    #     content << hidden_field_tag("#{temp_field_name}[count]",@attribute_value.add_more_counter ,:class=>"list_count")
    #     content << hidden_field_tag("#{temp_field_name}[count]",get_basic_field_name_base,:class=>"field_name")
    #     content
    #   end # of span
    # end # of div
  end

  def end_block
    if @new_attribute
      hidden_field_tag(get_basic_field_name_base+"[#{get_basic_field_name}_id]",id,:for=>"field_#{@index}", :id=>nil)
    else
      hidden_field_tag(get_basic_field_name_base+"[id]",@attribute_value.id,:for=>"field_#{@index}", :id=>nil)
    end
  end

  def add_more_tab(mode,counter,key)
    case mode
    when :input_field
      get_pairing_tab_class(:suffix=>['','tab'+counter.to_s,key].join('-'))
    when :tab_btn
      ".#{get_pairing_tab_class(:suffix=>['','tab'+counter.to_s,key].join('-'))}"
    end
  end

  def get_pairing_tab_class(opts)
    prefix = opts[:prefix]
    suffix = opts[:suffix]
    str = get_basic_field_name_base.gsub("[","_").gsub("]",'')
    str = prefix.nil? ? str : prefix+ str 
    suffix.nil? ? str : str + suffix
  end

  def get_basic_field_name_org
    "seminar_signup_values"
  end

  def get_basic_field_name
    "seminar_signup_field"
  end

  def get_basic_field_name_base
    "#{get_basic_field_name_org}[#{@index}]"
  end

  def get_field_name_base
    get_basic_field_name_base + "[value]"
  end

  def form_label
    if self.markup == "text_area"
      plc = typeD["placeholder"][I18n.locale].to_s.blank? ? nil : "(#{typeD["placeholder"][I18n.locale]})"
      label_tag(key, '' , :class=>"col-sm-2 control-label muted") do
        concat (!@require.blank? ? '*'+title : title)
        if plc
          concat tag(:br)
          concat plc
        end
      end
    else
      label_tag(key,(!@require.blank? ? '*'+title : title),:class=>"col-sm-2 control-label muted")
    end
  end

  def can_muti_lang_input?
    if self.markup == "address"
      return true
    else
      $seminar_list[:markups][markup]["muti_lang_input_supprt"] and !(get_data["cross_lang"] == "true")  
    end
  end

  def can_add_more
    if self.markup == "address"
      return false
    else
      add_more
    end
  end

  def gen_modal_dialog
    render_anywhere("shared/attribute_field/address_modal_dialog",{
        :field_name=>title,
        :html_id=>"address-field",
        :btn_class => "#{get_pairing_tab_class({})}",
        :field_name_basic => get_basic_field_name_base
          }
        )
  end
  def show_set_field(field_sets,key_field,key_index,field,markup='text_field')
    @show_set_field = true
    def self.can_muti_lang_input?
      true
    end
    def self.can_add_more
      false
    end
    @markup = markup
    def self.markup
      @markup
    end
    def self.add_more
      false
    end
    @new_attribute = false
    @key_index = key_index
    def self.key
      @key_index
    end
    def self.form_label
      ''
    end
    def self.end_block
      unless @attribute_value.new_record?
        hidden_field_tag("seminar_main[#{@key_field}][#{@key_index}]"+"[id]",
          @attribute_value.id,:for=>"field_#{@key_index}", :id=>nil)
      else
        ""
      end
    end
    @key_field = key_field
    @field = field
    def self.get_basic_field_name_base
      "seminar_main[#{@key_field}][#{@key_index}][#{@field}]"
    end
    def self.get_field_name_base
      "seminar_main[#{@key_field}][#{@key_index}][#{@field}]"
    end
    @attribute_value = field_sets
    @prefiled_value = field_sets[field]
    a = control_group_wrapper do |key,value|
      add_more_blank = ""
      if markup=='text_field'
        if key_field == 'seminar_email_sets'
          inside = text_field_tag([get_field_name_base,"[#{key}]"].join,value,:class=>'input-medium form-control')
        else 
          inside = text_field_tag([get_field_name_base,"[#{key}]"].join,value)
        end
      else
        inside = cktext_area("seminar_main[#{@key_field}][#{@key_index}][#{@field}]","#{key}",value:value)
      end
      inside
    end
    @key_field = nil
    @key_index = nil
    @field = nil
    @show_set_field = nil
    return a.html_safe
  end
end